<?php
//================================================================================
// PLEASE DO NOT REMOVE THIS HEADER!!!
//
// COPYRIGHT NOTICE
// This script is licensed under the GPL
// 
// Copyright 2007-2008 Alias 454 Studios and Brandon Keep (c) All rights reserved.
// Created 11/18/2007   
// Brandon Keep,    http://www.openautoclassifieds.com
//                  http://www.alias454studios.com/scripts/
//
// Last Modified 06-25-2009 by
// Brandon Keep,    http://alias454studios.com
//================================================================================
// This software IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
// OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.
//================================================================================

//set local variables
$dbtype = "MySQLi"; //choose db type you want to connect to use MySQL, MySQLi or PostGreSQL as examples
$dbhost = "localhost";
$dbuser = "dbuser";
$dbpass = "dbpass";
$dbname = "openauto";

//connection error messages used for database user and password or type failures
DEFINE("DATABASE_CONNECTION_ERROR","<h1>Fatal Error:</h1><p>Unable to connect to the database at this time.</p>");
DEFINE("DATABASE_LOCATION_ERROR","<h1>Fatal Error:</h1><p>Unable to locate the database at this time.</p>");
DEFINE("DATABASE_EMPTY_ERROR","<h1>Fatal Error:</h1><p>Unable to locate data it appears your database is empty.</p>");
DEFINE("DATABASE_UNSUPPORTED_DATABASE_TYPE_ERROR","<h1>Fatal Error:</h1><p>Your server does not support access to a $dbtype Database.</p>");
//debug message used when debugging is turn on or off
DEFINE("DEBUG_SQL_TURN_OFF_VERBOSE_MESSAGE","<h1>Fatal Error:</h1><p>There was an error somewhere in your script.</p>");

//choose the right connector to setup
switch($dbtype) {
	//connect to MySQL
	case 'MySQL':
		if (function_exists('mysql_connect')) {
			include_once "db.functions.$dbtype.php";
		}  else {
			die(DATABASE_UNSUPPORTED_DATABASE_TYPE_ERROR);
			exit();
		}
		break;
	//connect to MySQLi
	case 'MySQLi':
		if (function_exists('mysqli_connect')) {
			include_once "db.functions.$dbtype.php";
		}  else {
			die(DATABASE_UNSUPPORTED_DATABASE_TYPE_ERROR);
			exit();
		}
		break;
	//connect to PostGreSQL remapper functions are broken
	case 'PostGreSQL':
		//add some code for postgresql later
		if (function_exists('pg_pconnect')) {
			include_once "db.functions.$dbtype.php";
		}  else {
			die(DATABASE_UNSUPPORTED_DATABASE_TYPE_ERROR);
			exit();
		}
		break;
	default:
		die(DATABASE_LOCATION_ERROR);
		break;
}
?>