<?php
//================================================================================
// PLEASE DO NOT REMOVE THIS HEADER!!!
//
// COPYRIGHT NOTICE
// This script is licensed under the GPL
// 
// Copyright 2007-2008 Alias 454 Studios and Brandon Keep (c) All rights reserved.
// Created 11/18/2007   
// Brandon Keep,    http://www.openautoclassifieds.com
//                  http://www.alias454studios.com/scripts/
//
// Last Modified 07-01-2009 by
// Brandon Keep,    http://alias454studios.com
//================================================================================
// This software IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
// OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.
//================================================================================

include_once 'env.inc.php';

//Check if magic qoutes is on then stripslashes if needed
function codeClean($var)
{
    if (is_array($var)) {
		foreach($var as $key => $val) {
			$output[$key] = codeClean($val);
    	}
    } else {
		$var = strip_tags(trim($var));
		if (function_exists("get_magic_quotes_gpc")) {
			$output = sqlEscapeString((get_magic_quotes_gpc()) ? stripslashes($var) : $var);
		} else {
			$output = sqlEscapeString($var);
		}
	}
	//if (!empty($output)) 
	return $output;
}

function viewOnPage($var)
{
	if (is_array($var)) {
		foreach($var as $key => $val) {
			$output[$key] = viewOnPage($val);
    	}
    } else {
    	$var = htmlentities(trim($var), ENT_QUOTES, "UTF-8");
		if (function_exists("get_magic_quotes_gpc")) {
		   	$output = get_magic_quotes_gpc() ? stripslashes($var) : $var;
		} else {
			$output = $var;
		}
	}
	//if (!empty($output))
	return $output;
}

//Mail functions
function sendEmail($ToEmail,$Subject,$Body,$From,$FromEmail)
{
	$ver = phpversion();
	$Body = preg_replace("!<br \/>!","\n",$Body);

	$headers = '';
	$headers.="From: $From <$FromEmail>\n";
	$headers.="Reply-To: <$FromEmail>\n";
	$headers.="X-Sender: <$FromEmail>\n";
	$headers.="X-Mailer: PHP-$ver \n";
	$headers.="X-Priority: 3\n"; //1 UrgentMessage, 3 Normal
	$headers.="Return-Path: <$FromEmail> \n";

	mail($ToEmail,$Subject,wordwrap($Body),$headers);
}

//check contact us form for submission errors
function checkSubmitForm($from_email,$from_name,$subject,$msg,$captcha,$security_code)
{
	$error = '';
	if (!validateEmail($from_email)){
		$error[] = 1;
	}
	if (empty($from_name)) {
		$error[] = 2; 
	}
	if (empty($subject)) {
		$error[] = 3;
	}
	if (empty($msg)) {
		$error[] = 4;
	}
	if (!empty($security_code) && $security_code !== "$captcha") {
		$error[] = 5;
	}
	if (empty($captcha)) {
		$error[] = 6;
	} 
	if ($error) {
		return $error;
	} else {
		return 99;
	}
}

// function to check the referer for security reasons.
function checkReferer($referers) 
{
	$time = date('Y-m-d h:i');
	$referer = getenv("HTTP_REFERER");

   	//if the referrer is empty you will be redirected
	if (empty($referer)) {
		error_log(" $time Empty Referer. '" . getenv("REMOTE_ADDR") . "' \r\n", 3, "error.txt");
		header("Location: index.php");
		return false;
	} else {
		@list($remove,$stuff) = explode('//',$referer,2);
		@list($home,$stuff) = explode('/',$stuff,2);

		if (in_array($home,$referers)) {
			//print "".__LINE__." $home <-home $referer <-referer";
			return true;
		}

		//remove later if no bug reports
		/* for ($x = 0; $x < count($referers); ++$x) {
			if (preg_match("!$referers[$x]!","$home")) {
				//print "".__LINE__." $home <-home $referer <-referer";
				return true;
			}
		} */

		//if you get this far you have not met the criteria and will be redirected
		//if someone comes from a place other then in our referers list
		//set them in the right spot on our domain
		error_log(" $time Illegal Referer. '" . getenv("HTTP_REFERER") . "' \r\n", 3, "error.txt");
		header("Location: index.php");
		return false;
	}
}

//check status for use activation
function getActivationDefaults()
{
	global $use_listing_approval;
	
	if ($use_listing_approval) {
		//check if not an admin and set the proper status
		if (!isset($_SESSION["admin"])) {
			//if not admin set to 0 so listing has to be reapproved
			return 0;
		} else {
			//else we must be an admin so set to approved automaticlly
			return 1;
		}
	} else {
		//if use listing activation is turned off defaults to activated by default
		return 1;
	}
}

//Login functions
function verifyLogin($user,$pass)
{
	//Encrypt password for database verification
	$salt = 's+(_a*';
	$pass = md5($pass.$salt);

	$sql = "SELECT pass FROM users WHERE pass = '" . $pass . "' AND user = '" . $user ."'";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	$num = sqlNumRows($res);

	if ($num > 0)
		return true;
	return false;	
}

function verifyCookie($user,$pass)
{
	$sql = "SELECT pass FROM users WHERE pass = '" . $pass . "' AND user = '" . $user ."'";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	$num = sqlNumRows($res);
	
	if ($num > 0)
		return true;
	return false;	
}

//Page auth function
function checkPrivs()
{
	if (!empty($_SESSION["admin"])) {
		return 'admin';
	} elseif (!empty($_SESSION["seller"])) {
		return 'seller';
	} else {
		return 'user';
	}
}

function checkIfAdmin($user,$pass)
{
	$sql = "SELECT pass FROM users WHERE pass = '" . $pass . "' AND user = '" . $user ."' AND user_level = 9 ";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	$num = sqlNumRows($res);

	if ($num > 0)
		return true;
	return false;	
}

function checkIfSeller($user,$pass)
{
	$sql = "SELECT pass FROM users WHERE pass = '" . $pass . "' AND user = '" . $user ."' AND user_level = 2 ";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	$num = sqlNumRows($res);

	if ($num > 0)
		return true;
	return false;	
}

function logoff()
{
	global $visitor_tracking;

	//when logging off delete from the online users tables if user tracking is enabled
	if (!empty($visitor_tracking) && isset($_SESSION["user"])) {
		$sql = "DELETE FROM onlineusers WHERE user = '" . $_SESSION["user"] . "'";
		$del = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	}

	// remove all session variables and destroy session
	unset($_SESSION["user"]);
	unset($_SESSION["pass"]);
	unset($_SESSION["logged_in"]);
	unset($_SESSION["admin"]);

	session_destroy();

	if (isset($_COOKIE["user"])) {
		setcookie("user", NULL, time()-3600);
		setcookie("pass", NULL, time()-3600);
	}

	if (isset($_COOKIE[session_name()])) {
    	setcookie(session_name(), NULL, time()-3600);
	}

	// redirect them to anywhere you like.
	header("Location: login.php");
}

//Update account functions
function getUserRecords($user)
{
	$sql = "SELECT * FROM users WHERE user = '" . $user . "'"; 
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

	$c=0;
	while ($a_row = sqlFetchArray($res)) {
		$records[$c]["id"] = $a_row["id"];
		$records[$c]["email"] = $a_row["email"];
		$records[$c]["user"] = $a_row["user"];
		$records[$c]["company_name"] = $a_row["company_name"];
		$records[$c]["first_name"] = $a_row["first_name"];
		$records[$c]["last_name"] = $a_row["last_name"];
		$records[$c]["phone"] = $a_row["phone"];
		$records[$c]["alt_phone"] = $a_row["alt_phone"];
		$records[$c]["fax"] = $a_row["fax"];
		$records[$c]["image"] = $a_row["image"];
		$records[$c]["country"] = $a_row["country"];
		$records[$c]["address"] = $a_row["address"];
		$records[$c]["city"] = $a_row["city"];
		$records[$c]["state"] = $a_row["state"];
		$records[$c]["zip"] = $a_row["zip"];
		$records[$c]["reg_date"] = $a_row["reg_date"];
		$records[$c]["image"] = $a_row["image"];
	++$c;
    }
	if (!empty($records))
	    return $records;
}

function getUserDetails($id)
{
	if (!empty($id) && $id == "all") {
		//smarty paginate class used for users list in admin and also vehicle listings
		$paginate = new SmartyPaginate();
		//set the result query from listing number set
		$result_set_start = $paginate->getCurrentIndex();
		//set the result max query number
		$result_set_max = $paginate->getLimit();
		$page_limits = "LIMIT $result_set_start, $result_set_max";
	}

	if (!empty($id) && $id == "all") {
		$sql = "SELECT * FROM users ORDER BY id,approved DESC $page_limits";
		$count = "SELECT COUNT(*) FROM users";
		$count_res = sqlQuery($count); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		$row_count = sqlFetchRow($count_res);
	} else {
		$sql = "SELECT * FROM users WHERE id = " . $id . "";
	}

	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

	$c=0;
	while ($a_row = sqlFetchArray($res)) {
		 $records[$c]["id"] = $a_row["id"];
		 $records[$c]["ipaddress"] = ipConvert($a_row["ipaddress"]);
		 $records[$c]["user"] = $a_row["user"];
		 $records[$c]["email"] = $a_row["email"];
		 $records[$c]["company_name"] = $a_row["company_name"];
		 $records[$c]["first_name"] = $a_row["first_name"];
		 $records[$c]["last_name"] = $a_row["last_name"];
		 $records[$c]["phone"] = $a_row["phone"];
		 $records[$c]["alt_phone"] = $a_row["alt_phone"];
		 $records[$c]["fax"] = $a_row["fax"];
		 $records[$c]["country"] = $a_row["country"];
		 $records[$c]["address"] = $a_row["address"];
		 $records[$c]["city"] = $a_row["city"];
		 $records[$c]["state"] = $a_row["state"];
		 $records[$c]["zip"] = $a_row["zip"];
		 $records[$c]["reg_date"] = $a_row["reg_date"];
		 $records[$c]["last_active"] = $a_row["last_active"];
		 $records[$c]["user_level"] = $a_row["user_level"];
		 $records[$c]["notes"] = $a_row["notes"];
		 $records[$c]["image"] = $a_row["image"];
		 $records[$c]["activated"] = $a_row["activated"];
		 $records[$c]["approved"] = $a_row["approved"];
		 $records[$c]["admin_notes"] = $a_row["admin_notes"];
	++$c;
	}
	sqlFreeResult($res);

	if (!empty($id) && $id == "all") {
		//set total row count to count from query else defaults to 0
		$paginate->setTotal(!empty($row_count['0']) ? $row_count['0'] : 0);
		//$paginate->setTotal(count($records));
		if (!empty($records)) {
			//return array_slice($records, $paginate->getCurrentIndex(), $paginate->getLimit());
			return $records;
		}
	} elseif (isset($records)) {
		return $records; 
	}
}

function updateUser($user, $email, $company_name, $first_name, $last_name, $phone, $alt_phone, $fax, $country, $address, $city, $state, $zip)
{
	if (!validateEmail($email))	{
		return 1;
	} elseif (!validatePhone($phone)) {
		return 2;
	} elseif (!validateName($first_name)) {
		return 3;
	} elseif (!validateName($last_name)) {
		return 4;
	} else {
		// Get remote IP
		$ipaddress = ipConvertLong(getenv('REMOTE_ADDR'));
		$sql = "UPDATE users SET ipaddress = " . $ipaddress . ", email = '" . $email . "', company_name = '" . $company_name . "', first_name = '" . $first_name . "', last_name = '" . $last_name . "', phone = '" . $phone . "', alt_phone = '" . $alt_phone . "', fax = '" . $fax . "', country = '". $country . "', address = '". $address . "', city = '". $city . "', state = '". $state . "', zip = '". $zip . "' WHERE user = '" . $user . "'";		
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	return 99;
	}
}

//Reset password functions
function updatePass($user,$pass)
{
	//Encrypt password for database
	$salt = 's+(_a*';
	$new_password = md5($pass.$salt);
	//if user logged in change their session password 
	if (isset($_SESSION["pass"])) {
		$_SESSION["pass"] = "$new_password";
	}

	//if remember me function already set
	//change cookie for remember me
	if (isset($_COOKIE["pass"])) {
		setcookie("pass", "$new_password", time() + (60*60*24*30));
	}

	//perform sqlQuery and update user info in the database
	$sql = "UPDATE users SET pass = '" . $new_password . "' WHERE user = '" . $user . "'";
 	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
}

function generatePassword($len)
{
	$password = "";
	$char = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';

	$c=0;
	while ($c <= $len) {
		$random = rand(1,strlen($char));
		$password .= substr($char,$random -1,1);
	++$c;
	} 

	if (!empty($password))
	    return $password;//echo $password;
}
//Validation functions
function validateVin($vin)
{
	//http://www.geekpedia.com/code29_Check-if-VIN-number-is-valid.html
	//setup array values for vin check
	$check_digits = array('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'X');
	$model = array('A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'J', 'K', 'L', 'M', 'N', 'P', 'R', 'S', 'T', 'V', 'W', 'X', 'Y');
	$weight = array('8', '7', '6', '5', '4', '3', '2', '10', '9', '8', '7', '6', '5', '4', '3', '2');
	$char = array('A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'J', 'K', 'L', 'M', 'N', 'P', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9');
	$char_values = array('1', '2', '3', '4', '5', '6', '7', '8', '1', '2', '3', '4', '5', '7', '9', '2', '3', '4', '5', '6', '7', '8', '9', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9');
	$vin_char = array();

	$x=0;
	foreach ($char as $current_char) {
		$vin_char[$current_char] = $char_values[$x];
		++$x;
	}

	$c=0;
	$vin_array = array();
	for ($i = 0; $i < 17; $i++) {
		if ($i != 8) {
			$vin_array[$c] = substr($vin, $i, 1);
			++$c;
		}
	}

	$total = 0;
	for ($i = 0; $i < 16; $i++) {
			$this_digit = $vin_array[$i];
			$this_total = $weight[$i] * $vin_char[$this_digit];
			$total = $total + $this_total;
	}

	$remainder = fmod($total, 11);
	if (substr($vin, 8, 1) != $check_digits[$remainder]) {
			return false;
	} else {
			return true;
	}
}

function validatePhone($phone)
{
	if (preg_match('!^((\+\d{1,3}(-| )?\(?\d\)?(-| )?\d{1,5})|(\(?\d{2,6}\)?))(-| )?(\d{3,4})(-| )?(\d{4})(( x| ext)\d{1,5}){0,1}$!', $phone))
		return true;
	return false;
}

function validateName($name)
{
	$first = substr($name, 0, 1);
	if ($first == '.' || $first == '-' || $first == '_') {
		return false;
	}

	//if slashes are added remove them since this doesn't go in the db and we don't want names with \
	$name = str_replace('\\', '', $name);
	if (preg_match('!^[a-zA-Z\']+$!', $name))
    	return true;
	return false;
}

function validateUsername($user)
{
	$first = substr($user, 0, 1);
	if ($first == '.' || $first == '-' || $first == '_') {
		return false;
	}
	
	if (preg_match('!^[a-zA-Z0-9._-]{5,60}$!', $user))
    	return true;
	return false;
}

function validateEmail($email)
{
	if (preg_match("!^[a-zA-Z0-9]+([_\\.-][a-zA-Z0-9]+)*@([a-z0-9]+([\.-][a-z0-9]+)*)+\\.[a-z]{2,4}$!", $email))
   		return true;
	return false;
}

//Registration functions
function checkIfUser($user)
{
	$sql = "SELECT user FROM users WHERE user = '" . $user ."' ";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	$num = sqlNumRows($res);

	if ($num > 0)
		return true;
	return false;	
}

function checkIfEmail($email)
{
	if (isset($_SESSION["user"])) {
		$user = $_SESSION["user"];
		$sql = "SELECT * FROM users WHERE email = '" . $email ."' AND user = '" . $user ."'";
	} else {
		$sql = "SELECT * FROM users WHERE email = '" . $email ."' ";
	}
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	$num = sqlNumRows($res);
	
	if ($num > 0)
		return true;
	return false;	
}

//start user contributed functions verify by email[leowmjw]
function generateConfirmationID($user, $timestamp)
{
	$sql = "SELECT id FROM users WHERE user = '" . $user . "'";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

	// if cannot get anything back; croak and die
	if ($a_row = sqlFetchArray($res)) {
		return $timestamp . "-" . $a_row["id"];
	} else {
		return false;
	}
}

function updateUsername($uid, $user)
{
	$uid = codeClean($uid);
	$user = codeClean($user);
	$sql = "UPDATE users SET user = '" . $user . "', activated = 1 WHERE id = '" .$uid . "'";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

	// If succeed; return TRUE, else FALSE!!
	if (!empty($res))
		return $res;
	return false;
}

function getUsername($uid)
{
	$uid = codeClean($uid);
	$sql = "SELECT user FROM users WHERE id = '" . $uid ."'";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

	// if cannot get anything back; croak and die
	if ($a_row = sqlFetchArray($res))
		return $a_row["user"];
	return false;
}

function activateProfile($confirmationID)
{
	// Purpose: Activate a registered Profile based on a unique confirmation number
	// Returns: TRUE if all check passes and username is updated correctly
	//          FALSE if any check fails or anything bad happens.
	//          Reasons to fail:
	//              timestamp does not match
	//              wrong format
	// Check that it fits the regexp for confirmationID -- ^[0-9]-[0-9]+$ => ^{timestamp}-{uid}$
	// [bkeep] Changed if (!eregi("^([0-9]+)-([0-9]+)$", $confirmationID, $regs)) { 
	if (!preg_match_all("!^([0-9]+)-([0-9]+)$!", $confirmationID, $regs)) {
		//$error_code = "Confirmation ID - $confirmationID - is not valid!";
		//return false;
		return 1;
	}
	// If it fits the profile; split the string to the timestamp component and uid component
	// First parenthesis is for timestamp; second parenthesis is for user ID
	$timestamp = $regs[1][0];
	$uid = $regs[2][0];

	// Pull out the record based on the uid and compare if it fits the regexp
	if ($user = getUsername($uid)) {
		// If does not fit the pattern; possibly this username has already been activated!!!
		// [bkeep] Changed if (!eregi("^<([0-9]+)>-([A-Z0-9]{5,20})$", $user, $regs)) {
		if (!preg_match_all("!^<([0-9]+)>-([a-zA-Z0-9._-]{5,60})$!", $user, $regs)) {
			//$error_code = "The username - $user - has been activated!  Please login with this username!";
			//return false;
			return 2;
		}

		// Now we have the correct username
		// Pull out the original username component from the matching regexp
		// First parenthesis is for timestamp; second parenthesis is for username
		$stored_timestamp = $regs[1][0];
		$user = $regs[2][0];

		// Update DB with correct username if timestamp matches
		if ($timestamp == $stored_timestamp) {
			// If $user already exists in the system; must re-register!
			$res = updateUsername($uid, $user);
			if (!$res) {
				//$error_code = "User $user already exists on the system.  " . 'Please re-register at the <a href="register.php">Registration Page</a> with another username.';
				//return false;
				return 3;
			} else {
				//return $res;
				return 99;
			}
		} else {
			//$error_code = "The timestamp does not match with the records!";
			//return false;
			return 4;
		}
	} else {
		//$error_code = "Invalid uid!";
		//return false;
		return 5;
	}
}
//end user contributed function [leowmjw]

function registerUser($user, $pass, $email, $company_name, $first_name, $last_name, $phone, $alt_phone, $fax, $country, $address, $city, $state, $zip, $agree)
{
	global $admin_name;
	global $admin_email;
	global $default_user_level;
	global $use_verify_email;
	global $use_user_approval;

	$error = '';
	//todo work out better error handling routine
	if (checkIfUser($user))	{
		$error[] = 1;
	} 
	if (!validateEmail($email)) {
		$error[] = 2;
	} 
	if (!validateUsername($user)) {
		$error[] = 3;
	} 
	if (checkIfEmail($email)) {
		$error[] = 4;
	} 
	if (empty($agree)) {
		$error[] = 5;
	} 
	if (!validatePhone($phone)) {
		$error[] = 6;
	} 
	if (!validateName($first_name)) {
		$error[] = 7;
	} 
	if (!validateName($last_name)) {
		$error[] = 8;
	}
	if ($error) {
		return $error;
	} else {
		//if blank password one is generated then the details are emailed
		if (empty($pass)) {
			$pass = generatePassword(6);

			// If email verification functionality is enabled
			if ($use_verify_email) { 
				$body = preg_replace("!%USERNAME%!", "$user", ACCT_SIGNUP_BODY_VERIFY);
			} else {
 				$body = preg_replace("!%USERNAME%!", "$user", ACCT_SIGNUP_BODY);
			}
		} else {
			// If email verification functionality is enabled
			if ($use_verify_email) {
				$body = preg_replace("!%USERNAME%!", "$user", ACCT_SIGNUP_BODY_WPASS_VERIFY);
			} else {
				$body = preg_replace("!%USERNAME%!", "$user", ACCT_SIGNUP_BODY_WPASS);
			}
		}

		//build email to be sent from lang file
		$body = preg_replace("!%PASSWORD%!", "$pass", $body);
		//$body = preg_replace("!%URL%!", "$site_url/login.php", $body);
		$body = preg_replace("!%URL%!", OAC_SERVER_PATH."login.php", $body);
		//$subject = preg_replace("!%URL%!", "$site_url", ACCT_SIGNUP_SUBJECT);
		$subject = preg_replace("!%URL%!", OAC_SERVER_PATH, ACCT_SIGNUP_SUBJECT);
		$subject = preg_replace("!%USERNAME%!", "$user", $subject);
		//The last part of the email is at the bottom!!

	  	// Get remote IP
		$ipaddress = ipConvertLong(getenv('REMOTE_ADDR'));
		$reg_date = date("Y-m-d H:i:s");

	  	//Encrypt password for database
	    $salt = 's+(_a*';
		$pass = md5($pass.$salt);

		//Set the default activated status if not using the verify email functions
		$activated = 1;
		//Set the default user approval status
		$approved = 1;
		
		// If user approval functionality is enabled
		if ($use_user_approval)
			$approved = 0;

		// If email verification functionality is enabled
		if ($use_verify_email) {
			// Mangle username with timestamp to make sure user confirm e-mail address.
			// After e-mail is confirmed; this username will be unmangled
			// This will also set the actived status to 0 awaiting a proper verification 
			$timestamp = time();
			$user = "<" . $timestamp . ">-" . $user;
			$activated = 0;
		}

		//get default user level set by admin and insert
		$user_level = $default_user_level;
		$sql = "INSERT INTO users (ipaddress,user,pass,email,company_name,first_name,last_name,phone,alt_phone,fax,country,address,city,state,zip,reg_date,user_level,activated,approved) VALUES (" . $ipaddress . ", '" . $user . "','" . $pass . "', '" . $email . "', '" . $company_name . "', '" . $first_name . "', '" . $last_name . "', '" . $phone . "', '" . $alt_phone . "', '" . $fax . "', '" . $country . "', '" . $address . "', '" . $city . "', '" . $state . "', '" . $zip . "', '" . $reg_date . "', " . $user_level . ", " . $activated . ", " . $approved . ")"; 
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

		// If email verification functionality is enabled
		if ($use_verify_email) {
			// ConfirmationID ==> timestamp.uid
			$cid = generateConfirmationID($user, $timestamp);
			// Put in the correctly generated confirmation URL into the
			//$body = preg_replace("!%CONFIRMURL%!", "$site_url/login.php?verify=$cid", $body);
			$body = preg_replace("!%CONFIRMURL%!", OAC_SERVER_PATH."login.php?verify=$cid", $body);
		}
 
		// Send off the completed mail to user; with username and password in it.
		// Also will have confirmation URL if feature: validate email enabled.
		sendEmail($email,$subject,$body,$admin_name,$admin_email);
		return 99;
	}
}

//last avtive
function lastActive($user)
{
	global $visitor_tracking;

	$current_time = date("Y-m-d H:i:s");
	$ipaddress = ipConvertLong(getenv('REMOTE_ADDR'));

	//check if user is a guest or a logged in user
	//if logged in update the last active time in the users table and if activated the onlineusers table
	//if not logged in update the onlineusers table with correct guest info
	//checks for guest user first then checks if a user is logged in

	if (!empty($visitor_tracking) && $user == 'guest') {
		//guest is viewing check if already listed using their ip address in onlineusers table
		$sql = "SELECT ipaddress FROM onlineusers WHERE user = '" . $user . "' AND ipaddress = " . $ipaddress . "";
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		$num = sqlNumRows($res);
		if ($num > 0) {
			//if check showed result then perform an update to the onlineusers table
			$sql = "UPDATE onlineusers SET last_active = '" . $current_time . "', ipaddress = " . $ipaddress . " WHERE user = '" . $user . "' AND ipaddress = " . $ipaddress . "";
			$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		} else {
			//if check failed insert result in to the onlineusers table
			$sql = "INSERT INTO onlineusers (user,last_active,ipaddress) VALUES ('" . $user . "', '" . $current_time . "', " . $ipaddress . ")";
			$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		} 
	} elseif (!empty($visitor_tracking) && $user == $_SESSION["user"]) {
		//user is logged in check if they are listed in onlineusers table
		$sql = "SELECT user FROM onlineusers WHERE user = '" . $user . "'";
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		$num = sqlNumRows($res);
		if ($num > 0) {
			//if check showed result then perform the update to the tables users and onlineusers
			$sql = "UPDATE users,onlineusers SET users.last_active = '" . $current_time . "', onlineusers.last_active = '" . $current_time . "' WHERE onlineusers.user = users.user";
			$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		} else {
			//if check failed insert result in the onlineusers table
			$sql = "INSERT INTO onlineusers (user,last_active,ipaddress) VALUES ('" . $user . "', '" . $current_time . "', " . $ipaddress . ")";
			$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		}
	} else {
		//not using the visitor tracking feature so just update the last_active field for the user
		$sql = "UPDATE users SET last_active = '" . $current_time . "' WHERE user = '" . $user . "' ";
	}

	//perform some cleanup actions for the onlineusers table if visitor_tracking is enabled
	if (!empty($visitor_tracking)) {
		//now that we have checked the guest user or logged in user perform some cleanups of old dead userdata
		$sql = "SELECT * FROM onlineusers";
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		$num = sqlNumRows($res);

		//print "".__LINE__." $sql, $num, I am $user this is my ip $ipaddress<br />";
		if ($num > 0) {
			while ($a_row = sqlFetchArray($res)) {
				$id = $a_row["id"];
		 		$last_active_time = $a_row["last_active"];
				//print $last_active_time;
				
				//if last active time is less than last active time plus 5 minutes
				$last_active_timestamp = strtotime($last_active_time);
				$current_timestamp = strtotime(date("Y-m-d H:i:s"));
				//print "<br />$last_active_timestamp";
				//print "<br />$current_timestamp";

				$time_diff = ($current_timestamp-$last_active_timestamp);
				//print "<br />$time_diff";

				$time_diff_minutes = date("i",$time_diff);
				//print "<br /> $time_diff_minutes<br />";
				
				//delete the row from onlineusers if the current time is greater than last_active_time by x minutes
				if ($time_diff_minutes >= 5) {
					$sql = "DELETE FROM onlineusers WHERE id = '" . $id . "'";
					$del = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
					//print "it worked there is a difference of $time_diff_minutes minutes<br />";
				} else {
					//print "it did not work there is only a difference of $time_diff_minutes minutes<br />";
				}
			}
		}
	}
}

//Admin Functions
function updateEnv($env_data)
{
	$fieldstr = '';
	foreach ($env_data as $field => $value ) {
		if ("$value" !== SUBMIT) {
			$fieldstr .= "$field = '" . $value . "', ";
		}
	}
	$fields = substr($fieldstr, 0, -2);

	$sql = "UPDATE env_settings SET $fields";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

	if (!empty($res))
		return 99;
	return false;
}

function deleteUser($id)
{
	$user = getUsername($id);
	deleteUserImage($user);
	
	$sql = "DELETE FROM users WHERE id = " . $id . ""; 
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

	if (!empty($res))
		return 99;
	return false;
}

function updateUserDetails($details)
{
	$fieldstr = '';
	foreach ($details as $field => $value ) {
		if ($value !== UPDATE) {
			if ($field !== 'id') {
				$fieldstr .= "$field = '" . $value . "', ";
			}
		}
		if ($field == 'id') {
			$id = $value;
		}
	}
	$fields = substr($fieldstr, 0, -2);

	$sql = "UPDATE users SET $fields WHERE id = " . $id . "";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

	if (!empty($res))
		return 99;
	return false;
}

//function to convert from INET_ATON http://www.ipligence.com/en/faq/
//select INET_NTOA('3515134258');
function ipConvert($ip)
{
	$b = array(0,0,0,0);
	$c = 16777216.0;
	$ip += 0.0;
	for ($i = 0; $i < 4; ++$i) {
		$k = (int)($ip / $c);
		$ip -= $c * $k;
		$b[$i]= $k;
		$c /=256.0;
	}
	$d = join('.', $b);
	if (isset($d))
		return $d;
	return false;

}

function ipConvertLong($ip)
{
	$d = 0.0;
	$b = explode('.', $ip, 4);
	for ($i = 0; $i < 4; ++$i) {
		$d *= 256.0;
		$d += $b[$i];
	}
	if (isset($d))
		return $d;
	return false;
}

//Image functions
function checkImageSize($tmpfile, $max)
{
	//check the tmpimage file size and see if it is to big returns true if to large
	$size = filesize($tmpfile);
	if ($size > $max)
		return true;
	return false;
}

function checkAllowedExt($file)
{
	//check file for allowed extensions returns true if wrong type
	$temp = strtolower($file);
	$ext_split = explode('.', $temp);
	$ext = $ext_split[1];
	$allowed = array('gif', 'jpg', 'jpeg', 'png');
	if (!in_array($ext, $allowed))
		return true;
	return false;
}

function deleteUserImage($user)
{
	//look up old image path then remove the file before preceding with the new image upload
	$sql = "SELECT image FROM users WHERE user = '" . $user . "'";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	$row = sqlFetchAssoc($res);
	$del = $row["image"];
	if (!empty($del)) {
		$ext_split = explode('.', $del);
		$ext = $ext_split[1];
		$base = $ext_split[0];

		if (file_exists($del)) { 
			//user delete own image use normal path
			unlink("$del");
			unlink("$base" . "_thumb" . "." . "$ext");
		} else {
			//if admin is removing then adjust the path
			unlink("../$del");
			unlink("../$base" . "_thumb" . "." . "$ext");
		}
		$sql = "UPDATE users SET image = ''  WHERE user = '" . $user . "'";
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		return true;
	}
	return false;
}

function openImage($file)
{
	// Get extension and return it
	$temp = strtolower($file);
	$ext_split = explode('.', $temp);
	$ext = $ext_split[1];
	switch($ext) {
		case 'jpg':
		case 'jpeg':
			$im = @imagecreatefromjpeg($file);
			break;
		case 'gif':
			$im = @imagecreatefromgif($file);
			break;
		case 'png':
			$im = @imagecreatefrompng($file);
			break;
		default:
			$im = false;
			break;
	}
	return $im;
}

function createThumb($file, $ext, $width)
{
	$im    = openImage($file);
    $old_x = imageSX($im);
    $old_y = imageSY($im);
    $new_w = (int)($width);
    
	if (($new_w <= 0) or ($new_w>$old_x)) {
		$new_w=$old_x;
    }

    $new_h = ($old_x*($new_w/$old_x));

    if ($old_x > $old_y) {
        $thumb_w = $new_w;
        $thumb_h = $old_y*($new_h/$old_x);
    }
    if ($old_x < $old_y) {
        $thumb_w = $old_x*($new_w/$old_y);
        $thumb_h = $new_h;
    }
    if ($old_x == $old_y) {
		$thumb_w = $new_w;
		$thumb_h = $new_h;
    }
	
	$thumb = ImageCreateTrueColor($thumb_w,$thumb_h);
	
	if ($ext == 'png' || 'PNG') {
    	imagealphablending($thumb, false);
        $colorTransparent = imagecolorallocatealpha($thumb, 0, 0, 0, 127);
        imagefill($thumb, 0, 0, $colorTransparent);
        imagesavealpha($thumb, true);
	} elseif ($ext == 'gif' || 'GIF') {
    	$trnprt_indx = imagecolortransparent($im);
        if ($trnprt_indx >= 0) {
        	//its transparent
            $trnprt_color = imagecolorsforindex($im, $trnprt_indx);
            $trnprt_indx = imagecolorallocate($thumb, $trnprt_color['red'], $trnprt_color['green'], $trnprt_color['blue']);
            imagefill($thumb, 0, 0, $trnprt_indx);
            imagecolortransparent($thumb, $trnprt_indx);
		}
	}

    imagecopyresampled($thumb,$im,0,0,0,0,$thumb_w,$thumb_h,$old_x,$old_y);

	//choose which image program to use
	if ($ext == 'jpeg' || 'jpg' || 'JPEG' || 'JPG') {
		imagejpeg($thumb,$file,75);
	} elseif ($ext == 'png' || 'PNG') {
		imagepng($thumb,$file,75);
	} elseif ($ext == 'gif' || 'GIF') {
		imagegif($thumb,$file,75);
	}
    imagedestroy($thumb);
}

function moveUploadImage($path, $file, $tmpfile, $max, $user)
{
	//upload your image and give it a random name so no conflicts occour
	$rand = mt_rand(1,3000);
	$save_path = $path . $user . $rand . $file;
	
	//prep file for db and gd manipulation
	$save_path = str_replace(' ', '-', $save_path);
	$save_path = str_replace('&', '_', $save_path);

	//move the temp file to the proper place
	if (move_uploaded_file($tmpfile, $save_path)) {
		$ext_split = explode('.', $save_path);
		$ext = $ext_split[1];
		$base = $ext_split[0];

		copy($save_path, "$base" . "_thumb" . "." . "$ext");
		createThumb("$base" . "_thumb" . "." . "$ext", $ext, 150);
		//createThumb("$base" . "." . "$ext", $ext, 350);
		createThumb("$base" . "." . "$ext", $ext, 640);

		//chmod("$base" . "_thumb" . "." . "$ext", 0644);
		//chmod("$base" . "." . "$ext", 0644);

		return $save_path;
	}
	return false;
}

//upload the images for the members page
function uploadUserImage($path, $file, $tmpfile, $max, $user)
{
	if (empty($file))
		return false;
	if (checkImageSize($tmpfile, $max))
		return 1;
	if (checkAllowedExt($file))
		return 2;

	//look up old image path then remove the file before preceding with the new image upload
	$sql = "SELECT image FROM users WHERE user = '" . $user . "'";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	$row = sqlFetchAssoc($res);
	$del = $row["image"];
	if (!empty($del)) {
		$ext_split = explode('.', $del);
		$ext = $ext_split[1];
		$base = $ext_split[0];

		unlink("$del");
		unlink("$base" . "_thumb" . "." . "$ext");
	}

	//set approved status to not approved since listing was updated
	$approved = getActivationDefaults();

	$save_path = moveUploadImage($path, $file, $tmpfile, $max, $user);
	if (!empty($save_path)) {
		$sql = "UPDATE users SET approved = " . $approved . ", image = '" . $save_path . "' WHERE user = '" . $user . "' ";
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

		if ($res)
			return 99;
	}
	return false;
}

//upload the images for the listings pages
function uploadListImage($path, $file, $tmpfile, $max, $listingid, $user, $owner)
{
	if (empty($file))
		return false;
	if (checkImageSize($tmpfile, $max))
		return 1;
	if (checkAllowedExt($file))
		return 2;

	//check number of images then procede if less than max allowed
	//will work on this

	//see if listing already has main image set if not set image as main
	$sql = "SELECT COUNT(*) FROM listimages WHERE listingid = " . $listingid . " AND mainimage =1";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	$num = sqlFetchRow($res);

	$save_path = moveUploadImage($path, $file, $tmpfile, $max, $user);
	if (!empty($save_path)) {
		$ext_split = explode('.', $save_path);
		$ext = $ext_split[1];
		$base = $ext_split[0];
		$save_thumb_path = "$base" . "_thumb" . "." . "$ext";
	} else {
		return false;
	}

	//set default image status
	$approved = getActivationDefaults();
	
	if ($num['0'] > 0) {
		if (!empty($save_path)) {
			$sql = "INSERT INTO listimages (imagepath,imagethumbpath,mainimage,listingid,owner,approved) VALUES ('" . $save_path . "','" . $save_thumb_path . "',0, " . $listingid . ", '" . $owner . "', " . $approved . ")";
			$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
			return 99;
		}
	} else {
		if (!empty($save_path)) {
			$sql = "INSERT INTO listimages (imagepath,imagethumbpath,mainimage,listingid,owner,approved) VALUES ('" . $save_path . "','" . $save_thumb_path . "',1, " . $listingid . ", '" . $owner . "', " . $approved . ")";
			$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
			return 99;
		}
	}
	return false;
}

function approveImage($listingid, $imageid)
{
	if (!empty($listingid) && !empty($imageid)) {
		//check if image exists
		$sql = "SELECT id FROM listimages WHERE listingid = " . $listingid . " AND id = '" . $imageid . "'";
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		$num = sqlNumRows($res);
		if (!empty($num)) {
			$row = sqlFetchAssoc($res);
			$setimageid = $row["id"];

			//set image to approved
			$sql = "UPDATE listimages SET approved = 1 WHERE id = " . $setimageid . "";
			$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
			if (!$res)
				return false;
			return 99;
		}
	}
	return false;
}

function markImageMain($listingid, $imageid, $owner)
{
	//check if the admin is deleting the image or the image owner
	if (checkIfAdmin($_SESSION["user"],$_SESSION["pass"])) {
		$addOnSQL = "";
	} else {
		$addOnSQL = "AND owner = '" . $owner . "'";
	}

	if (!empty($listingid) && !empty($imageid) && !empty($owner)) {
		//check if already main and unset
		$sql = "SELECT id FROM listimages WHERE listingid = " . $listingid . " $addOnSQL AND mainimage = 1";
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		$num = sqlNumRows($res);
		if (!empty($num)) {
			$row = sqlFetchAssoc($res);
			$setimageid = $row["id"];

			$sql = "UPDATE listimages SET mainimage = 0 WHERE id = " . $setimageid . "";
			$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		} else {
			//return false;
			// Possibly, this happens when mainimage is deleted
            // Correct approach would be to mark this image as main!
			$sql = "UPDATE listimages SET mainimage = 1  WHERE id = " . $imageid . "";
			$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
			if (!$res)
				return false;
			return 99;
		}
	
		$sql = "UPDATE listimages SET mainimage = 1  WHERE id = " . $imageid . "";
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		if (!$res)
			return false;
		return 99;
	}
}

function quickApproveFullListing($listingid)
{
	$sql = "UPDATE listings SET approved = 1 WHERE id = " . $listingid . "";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	
	$sql = "SELECT id,listingid FROM listimages WHERE listingid = " . $listingid ."";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

	while ($a_row = sqlFetchArray($res)) {
		approveImage($a_row["listingid"], $a_row["id"]);
	}
	return 99;
}

function deleteFullListing($listingid)
{
	$sql = "DELETE FROM listings WHERE id = " . $listingid . ""; 
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	
	$sql = "SELECT * FROM listimages WHERE listingid = " . $listingid . ""; 
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

	$c=0;
	while ($a_row = sqlFetchArray($res)) {
		if (!empty($a_row["imagepath"]))
			unlink($a_row["imagepath"]);
		if (!empty($a_row["imagethumbpath"]))
			unlink($a_row["imagethumbpath"]);
	++$c;
    }

	$sql = "DELETE FROM listimages WHERE listingid = " . $listingid . ""; 
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	return 99;	
}

function deleteListingsImage($id, $imageid, $owner)
{
	//check if the admin is deleting the image or the image owner
	if (checkIfAdmin($_SESSION["user"],$_SESSION["pass"])) {
		$addOnSQL = "";
	} else {
		$addOnSQL = "AND owner = '" . $owner . "'";
	}

	if (!empty($id) && !empty($imageid) && !empty($owner)) {
		//look up image path then remove the files before preceding
		$sql = "SELECT imagepath,imagethumbpath,mainimage FROM listimages WHERE id = " . $imageid . " $addOnSQL LIMIT 1";
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		$num = sqlNumRows($res);
		if (!empty($num)) {
			$row = sqlFetchAssoc($res);
			$imagepath = $row["imagepath"];
			$imagethumbpath = $row["imagethumbpath"];
			$isMainImage = $row["mainimage"];
		} else {
			return false;
		}
	}

	if (!empty($imagepath)) {
		unlink("$imagepath");
		unlink("$imagethumbpath");

		$sql = "DELETE FROM listimages WHERE id = " . $imageid . " $addOnSQL ";
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

		// If everything OK AND IS MAIN IMAGE; select any remaining secondary and mark it as main
		if ($isMainImage) {
			$sql = "SELECT id,owner FROM listimages WHERE listingid = " . $id . " $addOnSQL LIMIT 1";
			$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
			$num = sqlNumRows($res);
			if ($num == 0) {
				// Nothing else to do .. get out of here!
				return 99;
			} else {
				// There still exists some listimages for this listing; so should mark the first found as mainimage!
				$row = sqlFetchAssoc($res);
				$secondary_imageid = $row["id"];
				$res = markImageMain($id, $secondary_imageid, $row["owner"]);
				if (!$res) {
					return false;
				} else {
					return 99;
				}
			}
		}
		//if the listing image was not the mainimage return true for delete record
		return 99;
	}
}

function getRandomImage()
{
	global $use_listing_approval;
	global $random_image_limit;
	$limit = $random_image_limit;
	$approved = '';

	if ($use_listing_approval) {
		if (!isset($_SESSION["admin"])) {
			if (isset($_SESSION["seller"])) {
				$approved = "";
			} else {
				$approved = "listings.approved = 1 AND listimages.approved = 1 AND ";
			}
		}
	}

	//get max id for list images so we can get random images
	$sql = "SELECT COUNT(id) FROM listimages";
	$max_res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	$row = sqlFetchRow($max_res);

	//check if the results are less than the initial $limit if so  
	//set the limit to the results
	if ($row['0'] < $limit) {
		$limit = $row['0'];
	}

	$returned_ids = array();
	//get the id for the list images as long as it passes our checks
	$sql = "SELECT listimages.listingid FROM listimages, listings WHERE $approved listings.id = listimages.listingid AND listimages.mainimage = 1";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

	while ($id_res = sqlFetchArray($res)) {
		$returned_ids[] = $id_res["listingid"];
	}

	//check if the results are less than the initial $limit if so  
	//set the limit to the results
	if (count($returned_ids) < $limit) {
		$limit = count($returned_ids);
	}

	//if we have results set the rand var else return false
	$random_id_keys = array();
	if ($returned_ids) {
		$random_id_keys = array_rand($returned_ids, $limit);

		$c=0;
		foreach ($returned_ids as $key => $value) {
			if (is_array($random_id_keys)) {
    			if (in_array($key, $random_id_keys, TRUE)) {
					//print "$key => $value<br />";
					$random_ids[] .= "$value";
					++$c;
				}
				if ($c == $limit) break;
			} else {
				return false;
			}
		}

		$rand = implode(',', $random_ids);
		//print "<br />$rand";
	} else {
		return false;
	}

	//random id checks are succesfull do a query
	$sql = "SELECT * FROM listings, listimages WHERE $approved mainimage = 1 AND listings.id = listimages.listingid AND listimages.listingid IN (" . $rand . ") AND listings.sold != 1 LIMIT $limit";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

	$c=0;
	while ($a_row = sqlFetchArray($res)) {
		$records[$c]["ad_title"] = $a_row["ad_title"];
		$records[$c]["make"] = $a_row["make"];
		$records[$c]["model"] = $a_row["model"];
		$records[$c]["listingid"] = $a_row["listingid"];
		$records[$c]["imagepath"] = $a_row["imagepath"];
		$records[$c]["imagethumbpath"] = $a_row["imagethumbpath"];
	++$c;
    }
	if (isset($records))
		return $records;
	return false;
}

function getListImages($listingid)
{
	global $use_listing_approval;
	$approved = '';

	if ($use_listing_approval) {
		if (!isset($_SESSION["admin"])) {
			if (isset($_SESSION["seller"])) {
				$sql = "SELECT seller FROM listings WHERE id = " . $listingid . " LIMIT 1";
				$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
				$a_row = sqlFetchAssoc($res);

				if ($a_row["seller"] == $_SESSION["user"]) {
					$approved = "";
				}
			} else {
				$approved = "approved = 1 AND ";
			}
		}
	}

	//look up image path for listing
	$sql = "SELECT * FROM listimages WHERE $approved listingid = " . $listingid . " ORDER BY id ASC";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

	$c=0;
	while ($a_row = sqlFetchArray($res)) {
		$records[$c]["id"] = $a_row["id"];
		$records[$c]["imagepath"] = $a_row["imagepath"];
		$records[$c]["imagethumbpath"] = $a_row["imagethumbpath"];
		$records[$c]["mainimage"] = $a_row["mainimage"];
		$records[$c]["listingid"] = $a_row["listingid"];
		$records[$c]["approved"] = $a_row["approved"];
	++$c;
	}
	if (isset($records))
		return $records;
}

function getListing($id='all', $addOnSQL="", $sellerid="", $sort="")
{
	global $use_listing_approval;
	$approved = '';
	$count = '';

	if (empty($sort))
		$sort = "ORDER BY sold,id DESC";

	if ($use_listing_approval) {
		if (!isset($_SESSION["admin"])) {
			if (isset($_SESSION["seller"])) {
				if ($sellerid == getSellerId($_SESSION["user"])) {
					$approved = "";
				}
			} else {
				if (!empty($id) && empty($addOnSQL) && $id == 'all') {
					$approved = "WHERE approved = 1";
				} else {
					$approved = "approved = 1 AND ";
				}
			}
		}
	}

	if (!empty($id) && $id == "all" || !empty($addOnSQL) && $id == 'search') {
		//smarty paginate class used for users list in admin and also vehicle listings
		$paginate = new SmartyPaginate();
		//set the result query from listing number set
		$result_set_start = $paginate->getCurrentIndex();
		//set the result max query number
		$result_set_max = $paginate->getLimit();
		$page_limits = "LIMIT $result_set_start, $result_set_max";
	}

	if (!empty($id) && empty($addOnSQL) && $id == 'all') {
		$sql = "SELECT * FROM listings $approved $sort $page_limits";
		$count = "SELECT COUNT(id) FROM listings $approved $sort";
	} elseif (!empty($addOnSQL) && $id == 'search') {
		$sql = "SELECT * FROM listings WHERE $approved $addOnSQL $sort $page_limits";
		$count = "SELECT COUNT(id) FROM listings WHERE $approved $addOnSQL $sort";
	} else {
		$sql = "SELECT * FROM listings WHERE id = " . $id . "";
	}

	if ($count) {
		$count_res = sqlQuery($count); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		$row_count = sqlFetchRow($count_res);
		sqlFreeResult($count_res);
	}

	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

	$c=0;
	while ($a_row = sqlFetchArray($res)) {
		$records[$c]["id"] = $a_row["id"];
		$records[$c]["approved"] = $a_row["approved"];
		$records[$c]["sold"] = $a_row["sold"];
		$records[$c]["featured"] = $a_row["featured"];
		$records[$c]["pending_removal"] = $a_row["pending_removal"];
		$records[$c]["ad_title"] = $a_row["ad_title"];
		$records[$c]["make"] = $a_row["make"];
		$records[$c]["model"] = $a_row["model"];
		$records[$c]["vehicle_type"] = $a_row["vehicle_type"];
		$records[$c]["doors"] = $a_row["doors"];
		$records[$c]["color"] = $a_row["color"];
		$records[$c]["mileage"] = $a_row["mileage"];
		$records[$c]["year"] = $a_row["year"];
		$records[$c]["listing_condition"] = $a_row["listing_condition"];
		$records[$c]["engine"] = $a_row["engine"];
		$records[$c]["trans"] = $a_row["trans"];
		$records[$c]["drive_train"] = $a_row["drive_train"];
		$records[$c]["mpg"] = $a_row["mpg"];
		$records[$c]["fuel_type"] = $a_row["fuel_type"];
		$records[$c]["price"] = $a_row["price"];
		$records[$c]["adddesc"] = $a_row["adddesc"];
		$records[$c]["features"] = explode(',', $a_row["features"]);
		$records[$c]["vin"] = $a_row["vin"];
		$records[$c]["stock"] = $a_row["stock"];
		$records[$c]["city"] = $a_row["city"];
		$records[$c]["state"] = $a_row["state"];
		$records[$c]["zip"] = $a_row["zip"];
		$records[$c]["sellerid"] = $a_row["sellerid"];
		$records[$c]["seller"] = $a_row["seller"];
		$records[$c]["added_on"] = $a_row["added_on"];
		$records[$c]["last_updated"] = $a_row["last_updated"];
		$records[$c]["hitcount"] = $a_row["hitcount"];
		$records[$c]["images"] = getListImages($a_row["id"]);
	++$c;
	}
	sqlFreeResult($res);

	if (!empty($id) && $id == "all" || !empty($addOnSQL) && $id == 'search') {
		//set total row count to count from query else defaults to 0
		$paginate->setTotal(!empty($row_count['0']) ? $row_count['0'] : 0);
		if (!empty($records)) {
    		//return array_slice($records, $paginate->getCurrentIndex(), $paginate->getLimit());
			return $records; 
		}
	} elseif (isset($records)) {
		return $records; 
	}
}

function updateHitCounter($listingid)
{
	$sql = "UPDATE listings SET hitcount = hitcount+1 WHERE id = " . $listingid . "";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
}

//add classifieds options
function addOption($option, $table)
{
	//check if empty if empty return no good
	if (empty($option))
		return false;

	//check if option already exists if it does return an error
	$sql = "SELECT * FROM $table WHERE $table = '" . $option ."'";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	$num = sqlNumRows($res);
	if ($num > 0) {
		return 1;
	} else {
		//if the option is not empty and does not exist then add it
		$sql = "INSERT INTO $table ($table) VALUES ('" . $option . "')"; 
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		return 99;
	}
}

//get search list data for search page
function getSearchList($table)
{
	global $use_listing_approval;
	$approved = '';
	
	if ($use_listing_approval)
			$approved = "WHERE approved = 1";
	
	$sql = "SELECT $table FROM listings $approved GROUP BY $table ORDER by $table"; 
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	
	$c=0;
	while ($a_row = sqlFetchArray($res)) {
		 $searchlist[$c]["$table"] = $a_row["$table"];
	++$c;
    }
	if (isset($searchlist))
		return $searchlist;
}

//Get option information lists
function getCountryList()
{
	$sql = "SELECT * FROM country ORDER by name"; 
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	
	$c=0;
	while ($a_row = sqlFetchArray($res)) {
		 $countrylist[$c]["country_id"] = $a_row["country_id"];
		 $countrylist[$c]["name"] = $a_row["name"];
		 $countrylist[$c]["iso_code_2"] = $a_row["iso_code_2"];
		 $countrylist[$c]["iso_code_3"] = $a_row["iso_code_3"];
	++$c;
    }
	if (isset($countrylist))
		return $countrylist;
}

function getStatesList()
{
	$sql = "SELECT * FROM states ORDER by state_name"; 
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	
	$c=0;
	while ($a_row = sqlFetchArray($res)) {
		 $stateslist[$c]["state_prefix"] = $a_row["state_prefix"];
		 $stateslist[$c]["state_name"] = $a_row["state_name"];
	++$c;
    }
	if (isset($stateslist))
		return $stateslist;
}

function getTableDataList($table)
{
	$sql = "SELECT * FROM $table ORDER by $table ASC"; 
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	
	$c=0;
	while ($a_row = sqlFetchArray($res)) {
		 $records[$c]["id"] = $a_row["id"];
		 $records[$c]["$table"] = $a_row["$table"];
	++$c;
    }
	if (isset($records))
		return $records;
}

function getFeaturesList()
{
	$sql = "SELECT * FROM features ORDER by features"; 
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	
	$c=0;
	while ($a_row = sqlFetchArray($res)) {
		 $featurelist[$c]["id"] = $a_row["id"];
		 $featurelist[$c]["features"] = $a_row["features"];
		 $featurelist[$c]["lists_default"] = $a_row["lists_default"];
	++$c;
    }
	if (isset($featurelist))
		return $featurelist;
}

function getSingleOption($table, $id)
{
	$sql = "SELECT * FROM $table WHERE id = " . $id . ""; 
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	$row = sqlFetchRow($res);
	if (isset($row)) 
		return $row;
	return false;
}

function updateSingleOption($table, $data, $id, $lists_default)
{
	//check if var for default list is set
	if (!empty($lists_default)) {
		if ($lists_default == 2) {
			$lists_default = "0";
		}
		$sql = "UPDATE $table SET lists_default = '" . $lists_default . "', $table = '" . $data . "' WHERE id = " . $id . "";		
	//otherwise update without it
	} else {
		$sql = "UPDATE $table SET $table = '" . $data . "' WHERE id = " . $id . "";		
	}

	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	return 99;
}

function deleteOption($table, $id)
{
	$sql = "DELETE FROM $table WHERE id = " . $id . "";		
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	return 99;
}

//gotta do something different here its getting out of hand
function updateListing($id, $ad_title, $make, $model, $vehicle_type, $doors, $color, $mileage, $year, $listing_condition, $engine, $trans, $drive_train, $mpg, $fuel_type, $price, $adddesc, $features, $vin, $stock, $city, $state, $zip, $sold, $sellerid, $seller)
{
	//do some validation on our data to make sure it is proper
	$error = array();
	if (empty($make)) {
		$error[] = 1;
	}
	if (empty($model)) {
		$error[] = 2;
	}
	if (!empty($mileage)) {
		if (!ctype_digit($mileage)) {
			$error[] = 3;
		}
	}
	if (!empty($year)) {
		if (strlen($year) != 4) {
			$error[] = 4;
		} elseif (!ctype_digit($year)) {
			$error[] = 5;
		}
	}
	if (!empty($vin)) {
		$vin = strtoupper($vin);
		if (strlen($vin) != 17) {
			$error[] = 6;
		} else {
			if (!validateVin($vin)) {
				$error[] = 7;
			}
		}
	}
	if ($error) {
		return $error;
	} else {
		//set approved status to not approved since listing was updated
		$approved = getActivationDefaults();
	
		$sql = "UPDATE listings SET approved = " . $approved . ", ad_title = '" . $ad_title . "', make = '" . $make . "', model = '" . $model . "', vehicle_type = '" . $vehicle_type . "', doors = '" . $doors . "', color = '" . $color . "', mileage = '" . $mileage . "', year = '" . $year . "', listing_condition = '" . $listing_condition . "', engine = '" . $engine . "', trans = '" . $trans . "', drive_train = '" . $drive_train . "', mpg = '" . $mpg . "', fuel_type = '" . $fuel_type . "', price = '" . $price . "', adddesc = '" . $adddesc . "', features = '" . $features . "', vin = '" . $vin . "', stock = '" . $stock . "', city = '" . $city . "', state = '" . $state . "', zip = '" . $zip . "', sold = '" . $sold . "', sellerid = '" . $sellerid . "', seller = '" . $seller . "' WHERE id = " . $id . "";
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		return 99;
	}
}

function addListing($ad_title, $make, $model, $vehicle_type, $doors, $color, $mileage, $year, $listing_condition, $engine, $trans, $drive_train, $mpg, $fuel_type, $price, $adddesc, $features, $vin, $stock, $city, $state, $zip, $sellerid, $seller)
{
	//do some validation on our data to make sure it is proper
	$error = array();
	if (empty($make)) {
		$error[] = 1;
	}
	if (empty($model)) {
		$error[] = 2;
	}
	if (!empty($mileage)) {
		if (!ctype_digit($mileage)) {
			$error[] = 3;
		}
	}
	if (!empty($year)) {
		if (strlen($year) != 4) {
			$error[] = 4;
		} elseif (!ctype_digit($year)) {
			$error[] = 5;
		}
	}
	if (!empty($vin)) {
		$vin = strtoupper($vin);
		if (strlen($vin) != 17) {
			$error[] = 6;
		} else {
			if (!validateVin($vin)) {
				$error[] = 7;
			}
		}
	}

	if ($error) {
		return $error;
	} else {
		//set default activation status
		$approved = getActivationDefaults();

		$added_on = date('Y-m-d h:i');
		$sql = "INSERT INTO listings (approved, ad_title, make, model, vehicle_type, doors, color, mileage, year, listing_condition, engine, trans, drive_train, mpg, fuel_type, price, adddesc, features, vin, stock, city, state, zip, sellerid, seller, added_on) VALUES (" . $approved . ", '" . $ad_title . "', '" . $make . "', '" . $model . "', '" . $vehicle_type . "', '" . $doors . "', '" . $color . "', '" . $mileage . "', '" . $year . "', '" . $listing_condition . "', '" . $engine . "', '" . $trans . "', '" . $drive_train . "', '" . $mpg . "', '" . $fuel_type . "', '" . $price . "', '" . $adddesc . "', '" . $features . "', '" . $vin . "', '" . $stock . "', '" . $city . "', '" . $state . "', '" . $zip . "', '" . $sellerid . "', '" . $seller . "', '" . $added_on . "')";
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		
		$lastid = sqlLastInsert();
		return 99+$lastid;
	}
}

function getUserId($user)
{
	$sql = "SELECT id FROM users WHERE user = '" . $user . "' LIMIT 1";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	
	if (!empty($res)) {
		$row = sqlFetchAssoc($res);
		$id = $row["id"];
		return $id;
	} else {
		return false;
	}
}

function getSellerId($user)
{
	$sql = "SELECT id FROM users WHERE user = '" . $user . "' AND user_level = 2 LIMIT 1";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	
	if (!empty($res)) {
		$row = sqlFetchAssoc($res);
		$id = $row["id"];
		return $id;
	} else {
		return false;
	}
}

function getSellers()
{
	$sql = "SELECT * FROM users WHERE user_level = 2"; 
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

	$c=0;
	while ($a_row = sqlFetchArray($res)) {
		$records[$c]["id"] = $a_row["id"];
		$records[$c]["user"] = $a_row["user"];
		$records[$c]["first_name"] = $a_row["first_name"];
		$records[$c]["last_name"] = $a_row["last_name"];
	++$c;
    }
	if (isset($records))
		return $records;
}

function getSellerEmail($id)
{
	$sql = "SELECT email FROM users WHERE id = " . $id . " AND user_level = 2 LIMIT 1";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	
	if (!empty($res)) {
		$row = sqlFetchAssoc($res);
		$email = $row["email"];
		return $email;
	} else {
		return false;
	}
}

//Statistics functions used for counting all vehicles, sold vehicles etc...
function getTotalUserCountStatistics($active_status)
{
	global $visitor_tracking;

	//check online status of listings
	if (!empty($active_status) && $active_status == 'active') {
		$sql = "SELECT user FROM users WHERE approved = 1";
	} elseif (!empty($active_status) && $active_status == 'pending') {
		$sql = "SELECT user FROM users WHERE approved !=1";
	}  elseif (!empty($active_status) && $active_status == 'activated') {
		$sql = "SELECT user FROM users WHERE activated !=1";

	//check online status of guests or registered users
	} elseif (!empty($active_status) && $active_status == 'sellers') {
		$sql = "SELECT user FROM users WHERE user_level = 2";
	} 
	if (!empty($visitor_tracking)) {
		if (!empty($active_status) && $active_status == 'online') {
			$sql = "SELECT * FROM onlineusers WHERE user != 'guest'";
		} elseif (!empty($active_status) && $active_status == 'guest') {
			$sql = "SELECT * FROM onlineusers WHERE user = 'guest'";
		}
	}

	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	$num = sqlNumRows($res);
	
	if (isset($num))
		return $num;
}

function getVehicleCountStats()
{
	$sql = "SELECT manufacturer AS make FROM manufacturer GROUP BY manufacturer";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

	$c=0;
	while ($a_row = sqlFetchArray($res)) {
		$inner_sql = "SELECT COUNT(id) FROM listings WHERE make = '" . $a_row["make"] . "'";
		$inner_res = sqlQuery($inner_sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		$num = sqlFetchRow($inner_res);

		//$inner_num = sqlNumRows($inner_res);
		$inner_num = $num["0"];

		$records[$c]["make"] = $a_row["make"];
		$records[$c]["num"] = $inner_num;
	++$c;
	}

	if (!empty($records))
	    return $records;
}

function getVehiclePriceStats($min_price, $max_price)
{
	$sql = "SELECT COUNT(id) FROM listings WHERE price >= '" . number_format($min_price, 2, CURRENCY_SYMBOLS_DECIMAL_SEPARATOR, '') . "' AND price <= '" . number_format($max_price, 2, CURRENCY_SYMBOLS_DECIMAL_SEPARATOR, '') . "'";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	
	$c=0;
	while ($a_row = sqlFetchRow($res)) {
		$records[$c]["min_price"] = $min_price;
		$records[$c]["max_price"] = $max_price;
		$records[$c]["num"] = $a_row["0"];
		//$records[$c]["num"] = sqlNumRows($res);
	++$c;
	}

	if (!empty($records))
	    return $records;
}

function getTotalVehicleCount($active_status)
{
	if (!empty($active_status) && $active_status == 'sold') {
		$sql = "SELECT COUNT(id) FROM listings WHERE sold = 1";
	} else {
		$sql = "SELECT COUNT(id) FROM listings";
	}
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
	$num = sqlFetchRow($res);

	if (isset($num))
		return $num["0"];
}

?>