<?php
//================================================================================
// PLEASE DO NOT REMOVE THIS HEADER!!!
//
// COPYRIGHT NOTICE
// This script is licensed under the GPL version 2 or (at your option) any later version.
//   
// Last Modified 03-25-2009 by
// Brandon Keep,    http://alias454studios.com
//
// Original code Information. This script was modified from existing code:
// This script Deletes auto listings older than X days in Open Auto Classifieds
// This script emails the user that has posted a listing when that listing is = X days in Open Auto Classifieds
// This script Deletes users not activated after signup older than X days in Open Auto Classifieds
//
// Created by Carsfound.com
// Contact: webmaster@carsfound.com
// Link: Carsfound.com
//
// Usage: replace example.com with your domain
// lynx -dump http://example.com/admin/Includes/Crons/master_cron.php?access_key=<key_goes_here>
// wget -q http://example.com/admin/Includes/Crons/master_cron.php?access_key=<key_goes_here>
//================================================================================
// This software IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
// OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.
//================================================================================

require_once '../../../Includes/configs/functions.php';
if (file_exists("../../../Includes/language/$site_lang/global.php")) {
	include_once "../../../Includes/language/$site_lang/global.php";
} else {
	include_once "../../../Includes/language/en/global.php";
}

//check cron security key and if it matches perform enabled cron tasks
if (isset($_GET["access_key"])) {
	$submitted_key = codeClean($_GET["access_key"]);
}

if ($cron_access_key == $submitted_key) {
	//send an email to a user with listing older than X days
	if (!empty($enable_old_listings_email)) {
		print "<h2>Users Notified of Pending Listing Removal.</h2>";
	
		//subtracts X days from the current linux timestamp x = seconds * minutes * hours * days
		$days = round((time() - (60*60*24*$email_after_days))/86400); // set to 45 days by default
	
		//Retrieve the data from the "listings" table
		$sql = "SELECT id,sellerid,added_on FROM listings WHERE pending_removal !=1";
		$res = sqlQuery($sql) or die();
	
		while($a_row = sqlFetchArray($res)) {
			//Store the record of the "listings" then loop through database
			$addedon = $a_row['added_on'];
			$addedon = round(strtotime($addedon)/86400);
	
			//Compare added on to days in days
			if ($addedon == $days) {
				$sellerid = $a_row['sellerid'];
				$listingid = $a_row['id'];
	
				//update listing to pending_removal status
				$sql2 = "UPDATE listings SET pending_removal = 1 WHERE id = " . $listingid . "";
				$res2 = sqlQuery($sql2) or die();
	
				//Retrieve the data from the "users" table for
				$sql3 = "SELECT email FROM users WHERE id = " . $sellerid . "";
				$res3 = sqlQuery($sql3) or die();
				$row = sqlFetchRow($res3);
	
				//setup email variables
				$to_email = $row["0"];
				$from_name = $admin_name;
				$from_email = $admin_email;
				
				//build email from global lang file for listing expiry notification
				$subject = OLD_LISTING_NOTIFICATION_EMAIL_SUBJECT;
				$body = OLD_LISTING_NOTIFICATION_EMAIL_BODY;
	
				print "An email has been sent to $to_email.<br />";
				sendEmail($to_email,$subject,$body,$from_name,$from_email);
			}
		}
	}
	
	//delete all listing older than x days via a cron job
	if (!empty($enable_delete_old_listings)) {
		print "<h2>Vehicle Listings to Remove.</h2>";
	
		//subtracts X days from the current linux timestamp x = seconds * minutes * hours * days
		$days = time() - (60*60*24*$listing_delete_after_days); // set to 60 days by default
	
		// Retrieve all the data from the "listings" table
		$sql = "SELECT * FROM listings";
		$res = sqlQuery($sql) or die();
	
		while ($a_row = sqlFetchArray($res)) {
			//Compares timestamp and deletes row if greater than or equal to X days
			$addedon = $a_row['added_on'];
			$addedon = strtotime($addedon);
	
			if ($addedon <= $days) {
				$id = $a_row['id'];
				print "Listing id $id has been removed.<br />";
				deleteFullListing($id);
			}
		}
	}
	
	//delete all users older than x days that have not activated their account by email verification
	if (!empty($enable_delete_old_users)) {
		print "<h2>Inactive Users to Remove.</h2>";
	
		//subtracts X days from the current linux timestamp x = seconds * minutes * hours * days
		$days = time() - (60*60*24*$users_delete_after_days); // set to 15 days by default
	
		// Retrieve all the data from the "users" table where activated not equal 1 and not an admin
		$sql = "SELECT * FROM users WHERE activated !=1 AND user_level !=9";
		$res = sqlQuery($sql) or die();
		
		while ($a_row = sqlFetchArray($res)) {
			//Compares timestamp and deletes row if greater than or equal to X days
			//will not delete any admin user 
			$reg_date = $a_row['reg_date'];
			$reg_date = strtotime($reg_date);
			if ($reg_date <= $days) {
				$id = $a_row['id'];
				print "Inactive user id $id has been removed.<br />";
				deleteUser($id);
			}
		}
	}
}
?>
