<?php
//================================================================================
// PLEASE DO NOT REMOVE THIS HEADER!!!
//
// COPYRIGHT NOTICE
// This script is licensed under the GPL
// 
// Copyright 2007-2008 Alias 454 Studios and Brandon Keep (c) All rights reserved.
// Created 11/18/2007   
// Brandon Keep,    http://www.openautoclassifieds.com
//                  http://www.alias454studios.com/scripts/
//
// Last Modified 06-25-2009 by
// Brandon Keep,    http://alias454studios.com
//================================================================================
// This software IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
// OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.
//================================================================================

require_once './Includes/configs/functions.php';
if (file_exists("./Includes/language/$site_lang/global.php")) {
	include_once "./Includes/language/$site_lang/global.php";
} else {
	include_once "./Includes/language/en/global.php";
}
header("Content-Type: application/xml; charset='" . DOCUMENT_CHARSET . "'");

//setup default change frequency
$change_frequency = "monthly";
$xml = '';

//start building page for site map
$xml.= '<?xml version="1.0" encoding="utf-8" ?>';
$xml.= "\n";
$xml.= "<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">\n";

//set up main pages for site map
$xml.= "<url>\n";
	$xml.= "<loc>" . OAC_SERVER_PATH . "index.php</loc>\n";
	$xml.= "<priority>1.00</priority>\n";
	$xml.= "<changefreq>$change_frequency</changefreq>\n";
$xml.= "</url>\n";

$xml.= "<url>\n";
	$xml.= "<loc>" . OAC_SERVER_PATH . "search.php</loc>\n";
	$xml.= "<priority>0.80</priority>\n";
	$xml.= "<changefreq>$change_frequency</changefreq>\n";
$xml.= "</url>\n";

$xml.= "<url>\n";
	$xml.= "<loc>" . OAC_SERVER_PATH . "login.php</loc>\n";
	$xml.= "<priority>0.80</priority>\n";
	$xml.= "<changefreq>$change_frequency</changefreq>\n";
$xml.= "</url>\n";

$xml.= "<url>\n";
	$xml.= "<loc>" . OAC_SERVER_PATH . "register.php</loc>\n";
	$xml.= "<priority>0.80</priority>\n";
	$xml.= "<changefreq>$change_frequency</changefreq>\n";
$xml.= "</url>\n";

$xml.= "<url>\n";
	$xml.= "<loc>" . OAC_SERVER_PATH . "contact.php</loc>\n";
	$xml.= "<priority>0.80</priority>\n";
	$xml.= "<changefreq>$change_frequency</changefreq>\n";
$xml.= "</url>\n";

$xml.= "<url>\n";
	$xml.= "<loc>" . OAC_SERVER_PATH . "reset.php</loc>\n";
	$xml.= "<priority>0.80</priority>\n";
	$xml.= "<changefreq>$change_frequency</changefreq>\n";
$xml.= "</url>\n";

$xml.= "<url>\n";
	if ($use_fancy_urls) {
		$xml.= "<loc>" . OAC_SERVER_PATH . "listings/action/view/</loc>\n";
	} else {
		$xml.= "<loc>" . OAC_SERVER_PATH . "listings.php?action=view</loc>\n";
	}
	$xml.= "<priority>0.80</priority>\n";
	$xml.= "<changefreq>$change_frequency</changefreq>\n";
$xml.= "</url>\n";

//setup sub page categories for makes
$sql = "SELECT make FROM listings GROUP BY make";
$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

while ($a_row = sqlFetchArray($res)) {
	$xml.= "<url>\n";
		if ($use_fancy_urls) {
			$xml.= "<loc>" . OAC_SERVER_PATH . "listings/action/find/make/" . str_replace(' ', '-', $a_row["make"]) . "/</loc>\n";
		} else {
			$xml.= "<loc>" . OAC_SERVER_PATH . "listings.php?action=find&amp;make=" . str_replace(' ', '-', $a_row["make"]) . "</loc>\n";
		}
		$xml.= "<priority>0.71</priority>\n";
		$xml.= "<changefreq>$change_frequency</changefreq>\n";
	$xml.= "</url>\n";
}

// build xml content for site map
$sql = "SELECT id,make,model,sellerid,price FROM listings";
$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

while ($a_row = sqlFetchArray($res)) {
	//build single listing main page
	$xml.= "<url>\n";
		if ($use_fancy_urls) {
			$xml.= "<loc>" . OAC_SERVER_PATH . "listings/view/" . str_replace(' ', '-', $a_row["make"]) . "/" . str_replace(' ', '-', $a_row["model"]) . "/" . $a_row["id"] . "/</loc>\n";
		} else {
			$xml.= "<loc>" . OAC_SERVER_PATH . "listings.php?make=" . str_replace(' ', '-', $a_row["make"]) . "&amp;model=" . str_replace(' ', '-', $a_row["model"]) . "&amp;id=" . $a_row["id"] . "</loc>\n";
		}
		$xml.= "<priority>0.64</priority>\n";
		$xml.= "<changefreq>$change_frequency</changefreq>\n";
	$xml.= "</url>\n";

	/* //build sub pages from listings page
	$xml.= "<url>\n";
		$xml.= "<loc>" . OAC_SERVER_PATH . "poster/view/$a_row[id]/</loc>\n";
		$xml.= "<priority>0.51</priority>\n";
		$xml.= "<changefreq>$change_frequency</changefreq>\n";
	$xml.= "</url>\n";

	$xml.= "<url>\n";
		$xml.= "<loc>" . OAC_SERVER_PATH . "listings/seller/id/$a_row[sellerid]/</loc>\n";
		$xml.= "<priority>0.51</priority>\n";
		$xml.= "<changefreq>$change_frequency</changefreq>\n";
	$xml.= "</url>\n";

	//commented out for referrer issues
	$xml.= "<url>\n";
		$xml.= "<loc>" . OAC_SERVER_PATH . "contact/seller/$a_row[sellerid]/listing/$a_row[id]/</loc>\n";
		$xml.= "<priority>0.51</priority>\n";
		$xml.= "<changefreq>$change_frequency</changefreq>\n";
	$xml.= "</url>\n";

	$xml.= "<url>\n";
		$xml.= "<loc>" . OAC_SERVER_PATH . "tell-a-friend/$a_row[sellerid]/listing/id/$a_row[id]//</loc>\n";
		$xml.= "<priority>0.51</priority>\n";
		$xml.= "<changefreq>$change_frequency</changefreq>\n";
	$xml.= "</url>\n"; 

	$xml.= "<url>\n";
		$xml.= "<loc>" . OAC_SERVER_PATH . "paycalc/amount/$a_row[price]/</loc>\n";
		$xml.= "<priority>0.51</priority>\n";
		$xml.= "<changefreq>$change_frequency</changefreq>\n";
	$xml.= "</url>\n";	*/
}

$xml.= "</urlset>\n";

// send xml to client
print "$xml";

?>